/* mex -largeArrayDims adjointHankelmex.cc */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <locale.h>
#include "mex.h"

void mexFunction(int nout, mxArray *out[],
/* Output variables */
int nin, const mxArray *in[]) /* Input variables */
{
	double *S = static_cast<double*> (mxGetData(in[0]));
	int m = (int) mxGetM(in[0]);
	int n = (int) mxGetN(in[0]);
	int *HankelIndices = static_cast<int*> (mxGetData(in[1]));
	int m1 = (int) mxGetM(in[1]);
	int n1 = (int) mxGetN(in[1]);
	int numSumHankelIndices = m+n-1;
    /*printf("%d, %d\n", m,n);*/

    out[0] = mxCreateDoubleMatrix(0,0,mxREAL);
    mxSetM(out[0],numSumHankelIndices);
    mxSetN(out[0],1);
    mxSetPr(out[0], (double *)mxCalloc(numSumHankelIndices,sizeof(double)));
    double *sumHankelIndices = mxGetPr(out[0]);
    /*printf("%d, %d\n", m1+1,n1+1);*/

    int i,j,idx1,idx2;

    /*for (i=0;i<n;i++)
    {
    	for (j=0;j<m;j++)
    	{
			printf("%d ", HankelIndices[i*m+j]);
    	}
    }*/

    for (i=0;i<n;i++)
    {
    	for (j=0;j<m;j++)
    	{
    		idx1 = i*m+j;
    		idx2 = HankelIndices[idx1];
    		/*printf("%d, %d\n", idx1, idx2);*/
    		sumHankelIndices[idx2-1] = sumHankelIndices[idx2-1] + S[idx1];
    	}
    }
}
