clear; clc; close all;


%% Real data
trainTestRatio = 0.8; %% between 0 and 1, larger implies larger training data
seed = 2; % setting randomization seed for consistent output
dataset = 'parkinson'; % Other option is 'school'.

% Details of datasets present in the file generateTrainTestSplit.m
[data1,data1_test] = generateTrainTestSplit(dataset,trainTestRatio,seed);

%% Hyper-parameters
C = 1e2;
rank = 10;

%% Problem structure
problem.r = rank;
problem.C = C;
% Train data
problem.data = data1;
% Test data
problem.data_test = data1_test;
problem.d = size(problem.data(1).X, 2); % Number of features

%% Proposed

% Options are not mandatory
opts.maxiter = 30;
opts.tolgradnorm = 1e-6;
opts.maxinner = 30;
opts.tolrelgradnorm = 1e-10;
opts.method='tr'; 
opts.verbosity=2;% Full output.

% Run proposed algorithm
[Uopt, XZopt, infos, options] = fixedrank_mtfl(problem,[],opts);
