function [Ut_omega_sparse_U_omega_sparse_chol, myRidge, I_sparser, J_sparser, mask_sparser] = ...
        absoluteLoss_dual_get_LHS_for_Zdot_mex(U, lambda, I, J, mask, Z)
    d = size(mask,1);
    T = size(mask,2);
    myTol1 = 1e-5;
    myRidge = 1e-5;
    adot_index = (Z <= (1 - myTol1)*lambda) & (Z >= - (1 - myTol1)*lambda);
    I_sparser = I(adot_index);
    J_sparser = J(adot_index);
    mask_sparser = sparse(double(I_sparser), double(J_sparser), ones(length(I_sparser), 1), d, T, length(I_sparser));
    numThreads = 4; % parallelizing some components of the inner problem over tasks. Number should be increased if system supports it. 
    parallel_flag = true;% default value should be true. It is advised to contact authors if one is not able to run the code with parallel_flag as true. 
    if parallel_flag
        Ut_omega_sparse_U_omega_sparse_chol = myspbuildmatrix_parallel(mask_sparser, U.', 1/(2*myRidge), numThreads);% We need to take care of 1/myRidge multiplier.
    else
        Ut_omega_sparse_U_omega_sparse_chol = myspbuildmatrix(mask_sparser, U.', 1/(2*myRidge));% We need to take care of 1/myRidge multiplier.
    end
end
