function [Z,UtZ] = solve_l1_loss_dual(U,Y,mask,C,options)
    numThreads = 4; % parallelizing some components of the inner problem over tasks. Number should be increased if system supports it. 
    flag_parallel = true;% default value should be true. It is advised to contact authors if one is not able to run the code with parallel_flag as true. 
    if flag_parallel
        if options.innersolver==10 || options.innersolver==11 || options.innersolver==14
            [Z, UtZ] = myLiblinear_parallel_l1l2hub(U.',Y,mask,C,...
                options.innerepsilonsvr,options.innerrelgradtol,options.innermaxepoch,options.innersolver,numThreads);
        elseif options.innersolver==12 || options.innersolver==13
            [Z, UtZ] = myLiblinear_parallel_epssvr(U.',Y,mask,C,...
                options.innerepsilonsvr,options.innerrelgradtol,options.innermaxepoch,options.innersolver,numThreads);
        else
            fprintf('[solve_l1_loss_dual]Wrong option give for opts.innersolver %d\n', options.innersolver);
        end
    else
        if options.innersolver==10 || options.innersolver==11 || options.innersolver==14
            [Z, UtZ] = myLiblinear_l1l2hub(U.',Y,mask,C,...
                options.innerepsilonsvr,options.innerrelgradtol,options.innermaxepoch,options.innersolver);
        elseif options.innersolver==12 || options.innersolver==13
            [Z, UtZ] = myLiblinear_epssvr(U.',Y,mask,C,...
                options.innerepsilonsvr,options.innerrelgradtol,options.innermaxepoch,options.innersolver);
        else
            fprintf('[solve_l1_loss_dual]Wrong option give for opts.innersolver %d\n', options.innersolver);
        end
    end
end